Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang.reflect
Class Method

    java.lang.Object
      |
      +--java.lang.reflect.AccessibleObject
            |
            +--java.lang.reflect.Method

All Implemented Interfaces:
  Member

public final class Method
extends AccessibleObject
implements Member

A `Method` provides information about, and access to, a single method on a class or interface. The reflected method may be a class method or an instance method (including an abstract method).

A `Method` permits widening conversions to occur when matching the actual parameters to invokewith the underlying method's formal parameters, but it throws an `IllegalArgumentException` if a narrowing conversion would occur.

See Also:
  `Member`, `Class`, `Class.getMethods()`, `Class.getMethod(String, Class[])`, `Class.getDeclaredMethods()`, `Class.getDeclaredMethod(String, Class[])`

Fields inherited from interface java.lang.reflect.Member
`DECLARED, PUBLIC`

Method Summary
`boolean` | `equals(Object obj)` Compares this `Method` against the specified object.
`Class` | `getDeclaringClass()` Returns the `Class` object representing the class or interface that declares the method represented by this `Method` object.
`Class[]` | `getExceptionTypes()` Returns an array of `Class` objects that represent the types of the exceptions declared to be thrown by the underlying method represented by this `Method` object.
`int` | `getModifiers()` Returns the Java language modifiers for the method represented by this `Method` object, as an integer.
`String` | `getName()` Returns the name of the method represented by this `Method` object, as a `String`.
`Class[]` | `getParameterTypes()` Returns an array of `Class` objects that represent the formal parameter types, in declaration order, of the method represented by this `Method` object.
`Class` | `getReturnType()` Returns a `Class` object that represents the formal return type of the method represented by this `Method` object.
`int` | `hashCode()` Returns a hashcode for this `Method`.
`Object` | `invoke(Object obj, Object[] args)` Invokes the underlying method represented by this `Method` object, on the specified object with the specified parameters.
`String` | `toString()` Returns a string describing this `Method`.

Methods inherited from class java.lang.reflect.AccessibleObject
`isAccessible, setAccessible, setAccessible`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Method Detail

### getDeclaringClass

    public Class getDeclaringClass()

  Returns the `Class` object representing the class or interface that declares the method represented by this `Method` object.
  Specified by:
    `getDeclaringClass` in interface `Member`

### getName

    public String getName()

  Returns the name of the method represented by this `Method` object, as a `String`.
  Specified by:
    `getName` in interface `Member`

### getModifiers

    public int getModifiers()

  Returns the Java language modifiers for the method represented by this `Method` object, as an integer. The `Modifier` class should be used to decode the modifiers.
  Specified by:
    `getModifiers` in interface `Member`
  See Also:
    `Modifier`

### getReturnType

    public Class getReturnType()

  Returns a `Class` object that represents the formal return type of the method represented by this `Method` object.

### getParameterTypes

    public Class[] getParameterTypes()

  Returns an array of `Class` objects that represent the formal parameter types, in declaration order, of the method represented by this `Method` object. Returns an array of length 0 if the underlying method takes no parameters.

### getExceptionTypes

    public Class[] getExceptionTypes()

  Returns an array of `Class` objects that represent the types of the exceptions declared to be thrown by the underlying method represented by this `Method` object. Returns an array of length 0 if the method declares no exceptions in its `throws` clause.

### equals

    public boolean equals(Object obj)

  Compares this `Method` against the specified object. Returns true if the objects are the same. Two `Methods` are the same if they were declared by the same class and have the same name and formal parameter types and return type.
  Overrides:
    `equals` in class `Object`
  Following copied from class: `java.lang.Object`
  Parameters:
    `obj` - the reference object with which to compare.
  Returns:
    `true` if this object is the same as the obj argument; `false` otherwise.
  See Also:
    `Boolean.hashCode()`, `Hashtable`

### hashCode

    public int hashCode()

  Returns a hashcode for this `Method`. The hashcode is computed as the exclusive-or of the hashcodes for the underlying method's declaring class name and the method's name.
  Overrides:
    `hashCode` in class `Object`
  Following copied from class: `java.lang.Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### toString

    public String toString()

  Returns a string describing this `Method`. The string is formatted as the method access modifiers, if any, followed by the method return type, followed by a space, followed by the class declaring the method, followed by a period, followed by the method name, followed by a parenthesized, comma-separated list of the method's formal parameter types. If the method throws checked exceptions, the parameter list is followed by a space, followed by the word throws followed by a comma-separated list of the thrown exception types. For example:

          public boolean java.lang.Object.equals(java.lang.Object)

  The access modifiers are placed in canonical order as specified by "The Java Language Specification". This is `public`, `protected` or `private` first, and then other modifiers in the following order: `abstract`, `static`, `final`, `synchronized` `native`.

  Overrides:
    `toString` in class `Object`
  Following copied from class: `java.lang.Object`
  Returns:
    a string representation of the object.

### invoke

    public Object invoke(Object obj,
                         Object[] args)
                  throws IllegalAccessException,
                         IllegalArgumentException,
                         InvocationTargetException

  Invokes the underlying method represented by this `Method` object, on the specified object with the specified parameters. Individual parameters are automatically unwrapped to match primitive formal parameters, and both primitive and reference parameters are subject to widening conversions as necessary. The value returned by the underlying method is automatically wrapped in an object if it has a primitive type.

  Method invocation proceeds with the following steps, in order:

  If the underlying method is static, then the specified `obj` argument is ignored. It may be null.

  Otherwise, the method is an instance method. If the specified object argument is null, the invocation throws a `NullPointerException`. Otherwise, if the specified object argument is not an instance of the class or interface declaring the underlying method (or of a subclass or implementor thereof) the invocation throws an `IllegalArgumentException`.

  If this `Method` object enforces Java language access control and the underlying method is inaccessible, the invocation throws an `IllegalAccessException`.

  If the number of actual parameters supplied via `args` is different from the number of formal parameters required by the underlying method, the invocation throws an `IllegalArgumentException`.

  For each actual parameter in the supplied `args` array:

  If the corresponding formal parameter has a primitive type, an unwrapping conversion is attempted to convert the object value to a value of a primitive type. If this attempt fails, the invocation throws an `IllegalArgumentException`.

  If, after possible unwrapping, the parameter value cannot be converted to the corresponding formal parameter type by a method invocation conversion, the invocation throws an `IllegalArgumentException`.

  If the underlying method is an instance method, it is invoked using dynamic method lookup as documented in The Java Language Specification, section 15.11.4.4; in particular, overriding based on the runtime type of the target object will occur.

  If the underlying method is static, the class that declared the method is initialized if it has not already been initialized. The underlying method is invoked directly.

  Control transfers to the invoked method. If the method completes abruptly by throwing an exception, the exception is placed in an `InvocationTargetException` and thrown in turn to the caller of invoke.

  If the method completes normally, the value it returns is returned to the caller of invoke; if the value has a primitive type, it is first appropriately wrapped in an object. If the underlying method return type is void, the invocation returns null.

  Throws:
    `IllegalAccessException` - if the underlying method is inaccessible.
    `IllegalArgumentException` - if the number of actual and formal parameters differ, or if an unwrapping conversion fails.
    `InvocationTargetException` - if the underlying method throws an exception.
    `NullPointerException` - if the specified object is null and the method is an instance method.
    `ExceptionInInitializerError` - if the initialization provoked by this method fails.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Java is a trademark or registred trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2000 Sun Microsystems, Inc. 901 San Antonio Road,
Palo, Alto, California, 94303, U.S.A All Rights Reserved. < /font >